{
  inputs.pkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
  inputs.prisma-utils.url = "github:VanCoding/nix-prisma-utils";
  inputs.flake-utils.url = "github:numtide/flake-utils";

  outputs =
    { pkgs, prisma-utils, flake-utils, ... }:
      flake-utils.lib.eachDefaultSystem (system: let
      nixpkgs = pkgs.legacyPackages.${system};
      prisma =
        (prisma-utils.lib.prisma-factory {
          inherit nixpkgs;
          prisma-fmt-hash = "sha256-1E0RSlpFrY4UroZjOug8tr28sV+1TUgts4508hm9WDQ="; # just copy these hashes for now, and then change them when nix complains about the mismatch
          query-engine-hash = "sha256-ABmemJAwf2fM/2UkvFm56CJ29YBo7grAFFRs1R2O5qY=";
          libquery-engine-hash = "sha256-S4byVCgcb7aT0yxuK+jiYu+FeJTPbUJeOeLJdUpCCeU=";
          schema-engine-hash = "sha256-Fbi7bOjoN9uNnb7bF3CSVrHlIqrQHvXO70jZslVe4K0=";
        }).fromNpmLock
          ./package-lock.json; # <--- path to our package-lock.json file that contains the version of prisma-engines
    in
    {
      devShell = nixpkgs.mkShell {
        buildInputs = with nixpkgs; [ 
          nodejs_22
          nodePackages.prisma
        ]; 
        shellHook = prisma.shellHook;
      };
    });
}
